require '../mdpw.jar'
include Java
import Java::com.cwbp.mdpw.DataNote
import Java::com.cwbp.mdpw.DataSequence
import Java::com.cwbp.mdpw.DataChord
import Java::com.cwbp.mdpw.MIDIFilePlayer

module MdpwD
  def visit(v)
    visit_i(v, 0)
    return self
  end
end
class Visitor
  def process(mn, d)
  end
end

class Mn 
  include MdpwD
  def initialize(*p)
    if p.length > 0 then
     @pitch = p[0] 
    else 
     @pitch = -1
    end
    if p.length > 1 then
     @duration = p[1]
    else 
     @duration = -1
    end
    if p.length > 2 then
     @velocity = p[2]
    else 
     @velocity = -1
    end
    if p.length > 3 then
     @tone = p[3]
    else 
     @tone = -1
    end
#    print @pitch+", "+ @duration+", "+ @velocity+", "+ @tone
  end
  def getClass
    return DataNote.new(@pitch, @duration, @velocity, @tone)
  end
  def visit_i(v, d)
    v.process(self, d)
  end
  def setVelocity(v)
    @velocity = v
  end
  def getDuration
    return @duration
  end
end
class Ms < Array
  include MdpwD
  def getClass
    r = DataSequence.new()
    each do |i|
      r.addElement(i.getClass())
    end 
    return r
  end
  def getDuration
    r = 0
    ld = 0
    each do |i|
      d = i.getDuration()
      if d == -1 then
        d = ld
      else
        ld = d
      end
      r+= d
    end 
    return r
  end
  def visit_i(v, d)
    td = d
    each do |i|
      i.visit_i(v, td)
      id = i.getDuration()
      if d == -1 then
        id = ld
      else
        ld = id
      end
      td += id
    end
  end
end
class Mc < Array
  include MdpwD
  def getClass
    r = DataChord.new()
    each do |i|
      r.addElement(i.getClass())
    end 
    return r
  end
  def getDuration
    if length > 0 then
      return self[0].getDuration();
    else 
      return 0
    end
  end
  def visit_i(v, d)
    each do |i|
      i.visit_i(v, d)
    end
  end

end
class MidiFilePlayer < MIDIFilePlayer
  def play(m)
   super(m.getClass())
  end
end

module Mdpw
 def convert(d)
   case d
   when MdpwD
     puts "MdpwD"
     return d
   when Array
     case d[0]
     when "n"
       if d.length < 2 
         return Mn.new()
       end
       if d.length < 3 
         return Mn.new(d[1])
       end
       if d.length < 4 
         return Mn.new(d[1], d[2])
       end
       if d.length < 5 
         return Mn.new(d[1], d[2], d[3])
       end
       return Mn.new(d[1], d[2], d[3], d[4])
     when "s"
       r = Ms.new()
       i = 1
       while i < d.length
         r << convert(d[i])
         i += 1
       end
       return r
     when "c"
       r = Mc.new()
       i = 1
       while i < d.length
         r << convert(d[i])
         i += 1
       end
       return r
     end
   end
 end
 module_function :convert
end
