require "mdpw"

class Crescendo < Visitor
  def initialize(d, sv, en)
    @duration = d
    @startv = sv
    @endv = en
  end
  def process(mn, d)
    mn.setVelocity((@endv - @startv)*d/@duration+@startv)
  end
end

seq = Ms.new([Mn.new(60,1,64,1), Mn.new(62,1,64,1), Mn.new(64,1,64,1) ])
v = Crescendo.new(seq.getDuration(), 32, 120)

seq.visit(v)

p = MidiFilePlayer.new
p.init('visitor.mid')
p.setTempo(120)
p.play(seq)
p.end()

