from com.cwbp.mdpw import *
import sys.stderr
import copy
class visitor:
 def process(self, n, d): abstract

class mdpw_d:
  def copy(self):
    return copy.copy(self)
  def deepcopy(self):
    return copy.copy(self)
  def getDuration(self): abstract
  def visit(self, v):
    self.visit_i(v, 0)
    return self;
    
class mn(mdpw_d):
  def __init__(self, p, d = -1, v =-1, t = -1):
    self.pitch = p
    self.duration = d
    self.velocity = v
    self.tone = t
  def getPitch(self):
   return self.pitch
  def setPitch(self, p):
   self.pitch = p
  def getDuration(self):
   return self.duration
  def setDuration(self, d):
   self.duration = d
  def getVelocity(self):
   return self.velocity
  def setVelocity(self, v):
   self.velocity = v
  def getTone(self):
   return self.tone
  def setTone(self, t):
   self.tone = t
  def getClass(self):
    return DataNote(self.pitch, self.duration, self.velocity, self.tone)
  def visit_i(self, v, d):
     v.process(self, d)
     
class mc(list, mdpw_d):
  def __init__(self, l = [], f = False):
    for i in l:
      if(f):
       i = copy.copy(i)
      self.append(i)
  def getClass(self):
    r = DataChord()
    for i in self:
      r.addElement(i.getClass())
    return r
  def getDuration(self):
   if(self.length > 0):
     return self[0].duration
   return 0
  def visit_i(self, v , d):
    for i in self:
      i.visit_i(v, d)
  def deepcopy(self):
    r = mc()
    for i in self:
      r.append(i.deepcopy())
    return r
    
class ms(list, mdpw_d):
  def __init__(self, l = [], f = False):
    for i in l:
      if(f):
       i = copy.copy(i)
      self.append(i)
  def getClass(self):
    r = DataSequence()
    for i in self:
      r.addElement(i.getClass())
    return r
  def visit_i(self, v , d):
    td = d;
    ld = 0;
    for i in self:
      i.visit_i(v, td)
      d = i.getDuration()
      if(d == -1):
        d = ld;
      else:
        ld = d;
      td += d
  def getDuration(self):
    ld = 0;
    r = 0
    for i in self:
      d = i.getDuration()
      if(d == -1):
        d = ld;
      else:
        ld = d;
      r += d
    return r
  def deepcopy(self):
    r = ms()
    for i in self:
      r.append(i.deepcopy())
    return r

class midifile_player(MIDIFilePlayer):
 def play(self, o):
  if issubclass(o.__class__, mdpw_d) :
    self.play(o.getClass())
  elif isinstance(o, Data):
    MIDIFilePlayer.play(self, o)
  else :
    print >> sys.stderr, "Invalid type" 
    
class converter:
 def list_convert(self, l):
  if l[0] == "n":
    if(len(l) > 4):
      print l
      return mn(l[1], l[2], l[3], l[4])
    if(len(l) > 3):
      return mn(l[1], l[2], l[3])
    if(len(l) > 2):
      return mn(l[1], l[2])
    if(len(l) > 1):
      return mn(l[1])
  elif l[0] == "s":
    r = ms()
    l.pop(0)
    for i in l:
      o = self.list_convert(i)
      if issubclass(o.__class__, mdpw_d):
        r.append(o)
    return r
  elif l[0] == "c":
    r = mc()
    l.pop(0)
    for i in l:
      o = self.list_convert(i)
      if issubclass(o.__class__, mdpw_d):
        r.append(o)
    return r
